#!/sbin/sh
# Original script
# Metamorph for OpenRecovery
# by -FuFu-
# edited by scheichuwe

APP_DIR=/sdcard/MetamorphRecovery/metamorph/$1
FONTS_DIR=/sdcard/MetamorphRecovery/metamorph/fonts/$1
SYS_DIR=/system/app
SYS_FRAME=/system/framework
BACKUP_DIR=/sdcard/MetamorphRecovery/backup/$1
BACKUP_DIR2=/sdcard/MetamorphRecovery/backup/$1/framework
BACKUP_FONTS=/sdcard/MetamorphRecovery/backup/$1/fonts

mkdir -p $BACKUP_DIR
mkdir -p $BACKUP_DIR2
if [ -d "$APP_DIR" ]; then
	for DIR in "$APP_DIR"/*
	do
	BASE_DIR=`basename "$DIR"`
	echo "Found $BASE_DIR"
		if [ -f "$SYS_DIR/$BASE_DIR.apk" ]; then
			echo -n "Create backup ..."
			cp -f $SYS_DIR/$BASE_DIR.apk $BACKUP_DIR
			echo "Done ..."
			echo -n "Add new files to $BASE_DIR ..."
			cd $DIR
			/sbin/zip -r -u $SYS_DIR/$BASE_DIR.apk * > /dev/null 2>&1
			echo "Done ..."
			/sbin/zipalign -c 4 $SYS_DIR/$BASE_DIR.apk > /dev/null 2>&1
			ZIPCHECK=$?
			if busybox [ $ZIPCHECK -eq 1 ]; then
				echo -n "Zipaligning $BASE_DIR.apk ..."  
				/sbin/zipalign -f 4 $SYS_DIR/$BASE_DIR.apk /cache/$BASE_DIR.apk > /dev/null 2>&1
				if busybox [ -e /cache/$BASE_DIR.apk ]; then
					busybox cp -f /cache/$BASE_DIR.apk $SYS_DIR/$BASE_DIR.apk  
					busybox rm /cache/$BASE_DIR.apk
					echo "Done ..."
				else
					echo "Failed." 
				fi
			else
				echo "Zipalign already completed on $BASE_DIR.apk "
			fi
				
		elif [ -f "$SYS_FRAME/$BASE_DIR.apk" ]; then
			echo -n "Create backup ..."
			cp -f $SYS_FRAME/$BASE_DIR.apk $BACKUP_DIR2
			echo "Done ..."
			echo -n "Add new files to $BASE_DIR ..."
			cd $DIR
			/sbin/zip -r -u $SYS_FRAME/$BASE_DIR.apk * > /dev/null 2>&1
			echo "Done ..."
			/sbin/zipalign -c 4 $SYS_FRAME/$BASE_DIR.apk > /dev/null 2>&1
			ZIPCHECK=$?
			if busybox [ $ZIPCHECK -eq 1 ]; then
				echo -n "Zipaligning $BASE_DIR.apk ..."  
				/sbin/zipalign -f 4 $SYS_FRAME/$BASE_DIR.apk /cache/$BASE_DIR.apk > /dev/null 2>&1
				if busybox [ -e /cache/$BASE_DIR.apk ]; then
					busybox cp -f /cache/$BASE_DIR.apk $SYS_FRAME/$BASE_DIR.apk  
					busybox rm /cache/$BASE_DIR.apk
					echo "Done ..."
				else
					echo "Failed." 
				fi
			else
				echo "Zipalign already completed on $BASE_DIR.apk "
			fi
		fi
	done
fi
echo -n "Looking for custom fonts ..."
if [ -d "$FONTS_DIR" ]; then
	echo "Done ..."
	echo -n "Install custom fonts ..."
	mkdir -p $BACKUP_FONTS
	cp -f /system/fonts/* $BACKUP_FONTS/
	cp -f $FONTS_DIR/* /system/fonts/
	chmod 644 /system/fonts/*
	echo "Done ..."
else
	echo "Done ..."
	echo "No custom fonts found."
fi
echo "All done ..."
exit 1